/*************************************************************************/
/*                                                                       */
/*   Program Name :  datacut                                             */
/*                                                                       */
/*      Version:  2.00  2006-01-30                                       */
/*                                                                       */
/*      Copyright (c) 2003-2006 T.Kondo/NICT(CRL) All Right Reserved     */
/*                                                                       */
/*************************************************************************/
/*
 ho|ukah{[h擾f[^t@C̎Ԕ͈͂
 f[^𒊏o

               Ver 0.00 2003.09.24
               Ver 1.00 2004.04.16  more robust fot data error
               Ver 1.01 2004.04.16  
               Ver 1.02 2004.11.16  
               Ver 1.03 2005.06.12  update due to update in common header name
               Ver 2.00 2006.01.30  support K5/VSSP32 format data

    点@datacut filename [soffset [period [outfile]]]
          filename -- f[^t@C
                            0 Ƃƃt@C
                            tds.datag
               soffset -- X^[gItZbgibj
                           ftHgl0
               period  -- of[^̎Ԓibj
                           ftHgl10
               outfile -- f[^o̓t@C
                           ftHgdatacut.dat


*/
#define DATACUT_VERSION "Ver. 2006-01-30"

#include "libk5.h"      // common header for IP-VLBI utilities

//D:\IPVLBI\data\k5vssp32\NK5_32M1b4ch-Noise.dat 0 3 test.dat
//G:\IPVLBI\data\JD0306\R1970008.dat 2 3 test.dat

int checkheader(ip_vlbi_file_t *S) // original is in libcor.c
{
/*
     2006-01-03

    Read 1st header to get sampling prameters and 
    to check sampler type either K5/VSSP or K5/VSSP32
    
       if first block is not header block, found header block automatically
       return value > 0 means above condition occurred
                    =-1 means EOF detection (file closed)

*/
      
       int iok, i, n, i32;
       int cdat[2]={1,4};
       int sdat[4]={1,2,4,8};
       int fdat[16]={40,100,200,500,1000,2000,4000,8000,16000, 
                     32000,64000,128000,256000,512000,1024000,2048000}; 
       union HEAD_VSSP hd;
       //fpos_t save;
       i32=0;
       iok=-1;

       S->vflag_old=S->vflag;                  // keep current valid flag
       S->dtime_vflag_old=S->dtime_vflag;  //keep time when vflag decision made
       S->vflag=0;

       //S->hd.format=0; // must be initialize before 1st time call!!

       hd.bbuf=S->hd.bhead;

       memset(S->hd.bhead, 0, 32);  // clear S->hd.head32 array with 0
       /* read 32bit data 1st*/
       S->bytesread = fread( S->hd.bhead, sizeof(char), 4, S->stream );
       if( ferror( S->stream ) || S->bytesread==0 ){
           if(S->bytesread==0){
               printf("checkheader: File EOF! (%s)\n",S->fname);
           } else {
               printf("checkheader: File Read Error! (%s)\n",S->fname);
           }
	       i=fclose( S->stream ) ;
           S->open_flag=0;
		   i32=-1;
           goto exit_end;
	   }

loop1:
       /* read 32 bit data and check sync patter by step-by-step */
       S->bytesread = fread( S->hd.bhead+4, sizeof( char ), 4, S->stream );
       if( ferror( S->stream ) || S->bytesread==0 ){
           if(S->bytesread==0){
               printf("checkheader: File EOF! (%s)\n",S->fname);
           } else {
               printf("checkheader: File Read Error! (%s)\n",S->fname);
           }
	       i=fclose( S->stream ) ;
           S->open_flag=0;
		   i32=-1;
           goto exit_end;
	   }
       /*  debug */
       /*
       printf("%02X%02X%02X%02X %02X\n",
           S->hd.bhead[0],S->hd.bhead[1],S->hd.bhead[2],S->hd.bhead[3],S->hd.bhead[7]);
       printf("%02X%02X%02X%02X %02X\n",
           hd.bbuf[0],hd.bbuf[1],hd.bbuf[2],hd.bbuf[3],hd.bbuf[7]);
       printf("%08X %02X\n",hd.hd->syncptn1,hd.hd->syncptn2);
       printf("totalsec0 %d %d\n",hd.hd->totalsec0, S->hd.bhead[5]*256+S->hd.bhead[4]);
       printf("AD SAMPLING %d %d %02X\n",hd.hd->bitwidth,hd.hd->fsample, S->hd.bhead[6]);
       exit(0);
       */
       /* check sync pattern */
       if(S->hd.format==0){
          if(hd.hd->syncptn1 == 0xFFFFFFFF && (unsigned char)hd.hd->syncptn2 == 0x8B) S->hd.format=1;// K5/VSSP
          if(hd.hd->syncptn1 == 0xFFFFFFFF && (unsigned char)hd.hd->syncptn2 == 0x8C) S->hd.format=2;// K5/VSSP32
          if(S->hd.format !=0){
             iok=0;  // sync detected
             S->hd.psync2=(unsigned char)hd.hd->syncptn2; // save second sync pattern
          }
       } else {
          if(hd.hd->syncptn1 == 0xFFFFFFFF && (unsigned char)hd.hd->syncptn2 == S->hd.psync2) iok=0;
       }
       if(iok==0){
           S->hd.sfreq=fdat[hd.hd->fsample];
           S->hd.adbit=sdat[hd.hd->bitwidth];
           S->hd.numch=cdat[hd.hd->chmode];
           S->hd.seconds=hd.hd->totalsec1*65536+hd.hd->totalsec0;
           sec2hms(S->hd.seconds,&S->hd.hh,&S->hd.mm,&S->hd.ss);
           if(S->hd.format == 2){ // more header read
                /* 1st read 4 byte to get AUX field size info */
                S->bytesread = fread( S->hd.bhead+8, sizeof( char ), 4, S->stream );
                if( ferror( S->stream ) || S->bytesread==0 ){
                    if(S->bytesread==0){
                        printf("checkheader: File EOF! (%s)\n",S->fname);
                    } else {
                        printf("checkheader: File Read Error! (%s)\n",S->fname);
                    }
	                i=fclose( S->stream ) ;
                    S->open_flag=0;
		            i32=-1;
                    goto exit_end;
                }
                S->hd.aux_size=hd.hd->auxsize;
                S->hd.year=hd.hd->year+2000;
                S->hd.totalday=hd.hd->totalday;
                S->hd.v_major=hd.hd->v_major;
                S->hd.v_minor=hd.hd->v_minor;
                //printf("debug1 %d %d %d\n",S->hd.aux_size,S->hd.year,S->hd.totalday);
                //printf("debug2 %d %d %d\n",S->hd.v_major,S->hd.v_minor,S->bytesread);

                /* read AUX field */
                S->bytesread = fread( S->hd.bhead+12, sizeof( char ), S->hd.aux_size, S->stream );
                if( ferror( S->stream ) || S->bytesread==0 ){
                    if(S->bytesread==0){
                        printf("checkheader: File EOF! (%s)\n",S->fname);
                    } else {
                        printf("checkheader: File Read Error! (%s)\n",S->fname);
                    }
	                i=fclose( S->stream ) ;
                    S->open_flag=0;
		            i32=-1;
                    goto exit_end;
                }
                /* parse AUX field data */
                S->hd.aux_fmt=hd.hd->fmt;
                S->hd.filter =hd.hd->filter;
                if(S->hd.aux_fmt==1 || S->hd.aux_fmt==2){
                    for(n=0; n<8; n++) S->hd.aux_hostname[n]=hd.hd->hostname[n];
                    S->hd.aux_hostname[8]='\0';
                    if(S->hd.aux_fmt==1){
                       for(n=0; n<8; n++) S->hd.aux_station[n]=hd.hd->station[n];
                       S->hd.aux_station[8]='\0';
                       S->hd.aux_sid2[0]=hd.hd->sid2[0]; S->hd.aux_sid2[1]=hd.hd->sid2[1];
                       S->hd.aux_sid2[2]='\0';
                    } else {
                       S->hd.aux_station[0]='\0';
                       S->hd.aux_sid2[0]='\0';
                    }
                } else {
                    S->hd.aux_hostname[0]='\0';
                    S->hd.aux_station[0]='\0';
                    S->hd.aux_sid2[0]='\0';
                }
                //printf("debug3 fmt,filter %d %d\n",S->hd.aux_fmt,S->hd.filter);
                //printf("debug4 host station sid2 (%s) (%s) (%s)\n",S->hd.aux_hostname,S->hd.aux_station,S->hd.aux_sid2);
               
           }
           goto exit_loop;
       } 
       if(i32 ==0) {
           printf("checkheader: First 64bit is not header block!\n");
           printf("checkheader:   Data file name (%s)\n",S->fname);
           printf("checkheader:   searching header.....");
       }
       /* read next 32 bit data */
       for (n=0; n<4; n++) S->hd.bhead[n]=S->hd.bhead[n+4];
       i32++;
       goto loop1;

exit_loop:

       if(i32 <0) return i32;
       if (iok == 0){   // sync detection
          if(i32 !=0) printf("  found after %d bits read!\n",i32*32);
          if(S->hd.format==1)
             printf("checkheader: Header (K5/VSSP) Sync Detected!!\n");
          if(S->hd.format==2)
             printf("checkheader: Header (K5/VSSP32) Sync Detected!!\n");
		  printf("checkheader:   File : %s\n",S->fname);
          printf("checkheader:   A/D(bits) %d  CHs %d  SFreq(kHz) %d",
                    S->hd.adbit,S->hd.numch, S->hd.sfreq);
          printf("  Time %02d:%02d:%02d  sec %d\n",
                    S->hd.hh,S->hd.mm,S->hd.ss,S->hd.seconds);
          // following 4 lines are just for keep backword compatibility
          // should be obsoleted 2006-01-03
          S->adbit=S->hd.adbit;
          S->numch=S->hd.numch;
          S->sfreq=S->hd.sfreq;
          S->hh=S->hd.hh; S->mm=S->hd.mm; S->ss=S->hd.ss; S->seconds=S->hd.seconds;
	   }
exit_end:
       if(i32 == 0) S->vflag=1;
       S->dtime_vflag=S->hd.seconds;
       //printf("checkheader:   vflag     dtime_vflag     %d %d\n",S->vflag,S->dtime_vflag);
       //printf("checkheader:   vflag_old dtime_vflag_old %d %d\n",S->vflag_old,S->dtime_vflag_old);
       return i32;
}


int fwdNsecHere(unsigned char* ibuf, int nsec, int numb, int imax,ip_vlbi_file_t *dat)
{
    int n, i;
    if(nsec <= 0) return 0;
    //printf("fwdNsec: nsec, numb, imax %d %d %d\n",nsec,numb,imax); //debug
    for(n=0; n<nsec; n++)
    {
        for(i=0; i< imax; i++)
        {
            dat->bytesread = fread( ibuf, sizeof( char ), numb, dat->stream );
            //printf("i, bytesread %d %d %d\n",i,dat->bytesread,ferror( dat->stream ));
            if( ferror( dat->stream ) || dat->bytesread==0 ){
                return -99;
            }
        }
        
        if(checkheader(&(*dat)) < 0){
             return -1;
        }
     }
     return 0;
}



int main(int argc, char *argv[])
{
       int sfreq, adbit, numch;
       long int smpl_count;    // sample number counts to extract
       long int counts;        //sample counter
       long int counts2;        //extract sample counter
       int nloop;
       int i,imax, m;
       int nerr;
       int smode,usampl;
       unsigned char *ibuf;
       int nbyte=5000;
       int bytesread;
       int bits, bytes, numb;
       int nch;
       double fsampl,tsampl,fact;
       int *idata;
       //double soffset, fsec, period;
       int soffset,period;
       //int soffset2;
       int extstart,hh,mm,ss;
       int nwrite;
       int headbyte;
       char fname[80],oname[80];
       char lab2[60], ltime1st[60];
       char labfsampl[10];
       char* dflt_fname="tds.data";
       char* dflt_oname="datacut.dat";
       ip_vlbi_file_t X;
       FILE *fo;

       if(argc == 1){
          printf("datacut %s\n",DATACUT_VERSION);
          printf("Usage: datacut filename [soffset [period [outfile]]]\n");
          printf("\n");
          printf("         where  filename ---- Data file name\n");
          printf("                             if 0 is given, tds.data will be used\n");
          printf("                soffset --- Start time offset in sec (integer seconds)\n");
          printf("                             default is 0\n");         
          printf("                period  --- Extracting period in sec (integer seconds)\n");
          printf("                             default is 10\n");         
          printf("                outfile ---- Extract data outfile name\n");
          printf("                             default is datacut.dat\n");         
          exit(0);
       }

       /* data file name get */
       strcpy(fname,*(argv+1));
       if (fname[0]=='0'){
          strcpy(fname,dflt_fname);
       }
       X.fname=fname;

       /* default set */
       soffset=0;     
       period=10;     
       strcpy(oname,dflt_oname);

       /* Start time offset get */
       if (argc>=3) soffset = atoi(*(argv + 2 ));

       /* Period to extract get */
       if (argc>=4) period = atoi(*(argv + 3 ));

       /* Out file name get */
       if (argc>=5) strcpy(oname,*(argv+4));

       /* Run condition monitor for debug*/
       //printf("Data File is %s\n",fname);
       //printf("nch, soffset, period  %d %f %f\n",nch,soffset,period);

       /* Program Name Display */
       printf("****************************************************\n");
       printf("*    IP-VLBI DATA TRUNCATION PROGRAM (datacut)     *\n");
       printf("*         %s    by  T.KONDO/NICT      *\n",DATACUT_VERSION);
       printf("****************************************************\n");
       printf("\n");

       /* Data file open */
       if( (X.stream  = fopen( X.fname, "rb" )) == NULL )
       {
           printf("Data File %s   Open Error! \n",fname);
           goto exitend2;
       }

       /* output file create */
       if( (fo  = fopen( oname, "wb" )) == NULL )
       {
          printf("File  %s  Open Error! \n",oname);
          goto exitend3;
       } 

       /* Data header check to get sampling parameters */
       X.hd.format=0;  // for 1st call  2006-01-03
       if(checkheader(&X) < 0){
            goto exitend3;
       }

       /* parameter set */
        sfreq=X.hd.sfreq;
        adbit=X.hd.adbit;
        numch=X.hd.numch;
        fsampl=1000.0*(float)sfreq;   // sampling frequency (Hz)
        tsampl=1.0/fsampl;            // sampling period (sec)
        bits=((long)fsampl)*adbit*numch;  // # of bits in 1 sec data except header
        bytes=bits/8;                     // # of bytes in 1 sec data except header
        X.fsample=(float)fsampl;

        /* Set extract Ch# to 1 in case of 1 ch board*/
        if(numch == 1){nch=1; }   


        /* File read buffer size set */
        smode=1;                         // low resolution mode

        if(smode ==1){ usampl=10000; }
        else {
           usampl=50000;
           if(sfreq == 40){ usampl=40000; }
           if(sfreq == 100){ usampl=100000; }
           if(sfreq == 200){ usampl=200000; }
        }
        imax=(sfreq*1000)/usampl;
        numb=usampl*adbit*numch/8;   // # of bytes in unit # of samples

        //printf("imax numb  %d %d\n",imax,numb);    //debug


        ibuf = (unsigned char *)malloc(numb);
        idata = (int *)malloc(4*usampl*sizeof(int));

        fact=((float)usampl)*((float)usampl);
        
        /* sampling frequency in text for print */
        if(sfreq == 40){strcpy(labfsampl,"40kHz"); }
        if(sfreq == 100){strcpy(labfsampl,"100kHz"); }
        if(sfreq == 200){strcpy(labfsampl,"200kHz"); }
        if(sfreq == 500){strcpy(labfsampl,"500kHz"); }
        if(sfreq == 1000){strcpy(labfsampl,"1MHz"); }
        if(sfreq == 2000){strcpy(labfsampl,"2MHz"); }
        if(sfreq == 4000){strcpy(labfsampl,"4MHz"); }
        if(sfreq == 8000){strcpy(labfsampl,"8MHz"); }
        if(sfreq == 16000){strcpy(labfsampl,"16MHz"); }
        if(sfreq == 32000){strcpy(labfsampl,"32MHz"); }
        if(sfreq == 64000){strcpy(labfsampl,"64MHz"); }

       /* Data extract start point set */ 
       //startoffset=(long int)soffset;
       //fsec=soffset-startoffset;
       //sofst_pos=(long int)(fsec/tsampl + 0.01);

       /* Data extraction period set */
       smpl_count=(long int)(period/tsampl + 0.01);

       /* Run condition display */

       //printf("startoffset, sofst_pos, smpl_count %d %d %d\n",startoffset,sofst_pos,smpl_count);
       printf("\n");
       printf("  Data File : %s",fname);
       if(X.hd.format == 1){
          printf(" (K5/VSSP format)\n");
       } else if (X.hd.format == 2){
          printf(" (K5/VSSP32 format)\n");
       } else {
          printf("\n");
       }
       printf("  Sampling Freq : %s\n",labfsampl);
       printf("  A/D bits      : %d\n",adbit);
       printf("  Number of CHs : %d\n",numch);
       printf("  Start Time(UT)        : %02d:%02d:%02d   Sec in Day = %d\n",
           X.hh,X.mm,X.ss,X.seconds);

       extstart=X.seconds+soffset;
       if(extstart >=86400) extstart-=86400;
       sec2hms(extstart, &hh,&mm,&ss);
       printf("  EXTRACT Start Time(UT): %02d:%02d:%02d   Sec in Day = %d\n",
           hh,mm,ss,extstart);

       /* foward startoffset seconds */
       printf("\n  %d seconds forwarding .....\n",soffset);

//          /* actual forward is 3 sec shorter for safety */
//       soffset2=soffset-3;
//       if(soffset2 > 0){
//           if(fwdNsecHere(ibuf, soffset2, numb, imax, &X) <0){
//               goto exitend;
//           }
//           nerr=checkheader(&X);
//       }
       // above 8 lines are substituted by follwoing 3 lines // 2006-01-30
       if((nerr=fwdNsecHere(ibuf, soffset, numb, imax, &X)) <0){
               if(nerr == -99) goto exitend;
       }
       if(X.seconds != extstart){ 
           while(X.seconds < extstart) nerr=checkheader(&X);
       }

       printf("\n  Positioning finished\n");
       printf("  Extraction starting....\n");

       //printf("  Time %02d:%02d:%02d   Sec in Day = %d\n",X.hh,X.mm,X.ss,X.seconds);
       sprintf(ltime1st,"Time(UT) %02d:%02d:%02d\0",X.hh,X.mm,X.ss);
       strcpy(lab2,ltime1st);

       /* continue run info display */
       printf("\n");
       printf("  Start Offset (sec)       : %d\n",soffset);
       printf("  Start Time of Extraction : %02d:%02d:%02d\n",X.hh,X.mm,X.ss);
       printf("  Period (sec)             : %d\n",period);
       printf("  Out File : %s\n",oname);

       /* Data extraction start */
       counts=0;
       counts2=0;
       m=nch-1;
       nloop=0;

       /* header byte number set */
       headbyte=8;
       if(X.hd.format==2){  // K5/VSSP32 format
           headbyte=12+X.hd.aux_size;
       }

       /* 1st header copy */
       //nwrite = fwrite( X.bit64, sizeof( char ), 8, fo);
       nwrite = fwrite( X.hd.bhead, sizeof( char ), headbyte, fo);


       /* Data read loop start here */

loop1:
        if(nloop >0) {
           if(nloop >= period) goto exithere;
           if(checkheader(&X) < 0) goto exitend; 
              //printf("  Time %02d:%02d:%02d   Sec in Day = %d\n",X.hh,X.mm,X.ss,X.seconds);
              //nwrite = fwrite( X.bit64, sizeof( char ), 8, fo);
              nwrite = fwrite( X.hd.bhead, sizeof( char ), headbyte, fo);
        }

        for(i=0; i< imax; i++)
        {
             bytesread = fread( ibuf, sizeof( char ), numb, X.stream );
             //printf("bytes read 2 %d\n",bytesread); //debug
             nwrite = fwrite( ibuf, sizeof( char ), numb, fo);
        }
        nloop++;
        goto loop1;
exithere:
       printf("\n");
       printf("Data truncation finished.\n");
       i=fclose( fo ) ;

exitend: 
       
       free(ibuf);
       free(idata);

exitend3: 
       i=fclose( X.stream ) ;

 exitend2: 

       return 0;
}
