/********************************************************************/
/*                                                                  */
/*   Program Name :  extdata                                        */
/*                                                                  */
/*      Version:  1.00  2006-01-31                                  */
/*                                                                  */
/*      Copyright (c) 2002-2006 T.Kondo/NICT All Right Reserved     */
/*                                                                  */
/********************************************************************/
/*
../mark5/O2880001.k5b 4 0 0.001

 ho|ukah{[h擾f[^t@C
 ̃f[^𒊏oAeLXgf[^Ƃďo͂

          T.Kondo 2002.8.27
               Ver 0.00 2002.08.27
               Ver 0.10 2002.10.11  18000->16000 bug fix 
               Ver 0.11 2005.06.12  update due to update in common header name
               Ver 1.00 2006.01.30  support K5/VSSP32 format data

    点@extdata filename [ch [soffset [period [omode [outfile]]]]]
          filename -- f[^t@C
                            0 Ƃƃt@C
                            tds.datag
               ch     -- o邃iPSj
                           ftHgl͂P
               soffset -- X^[gItZbgibj
                           ftHgl0.0
               period  -- of[^̎Ԓibj
                           ftHgl1.0
               omode   -- f[^o̓[h
                           0:wb_[t
                           1:wb_[
                           ftHgl0
               outfile -- f[^o̓t@C
                           ftHgextdata.txt


o̓eLXgt@C̗iTvOf[^͂PsɂQO_j
iwb_[ ** Ŏn܂ŏ̂Vsj

**  Data File : D:\IPVLBI\data\R2320002.dat (K5/VSSP format)
**  Sampling Freq : 4MHz
**  A/D bits      : 4
**  Number of CHs : 4
**  Extracted CH# : 1
**  Start Time of Data : 12:15:38.00000000
**  Period (sec)       : 0.010000
 10 6 8 8 9 7 8 6 7 8 8 7 9 8 8 8 8 10 7 8
 7 8 7 9 8 9 11 8 8 8 5 7 7 7 7 7 6 7 8 9
 8 9 7 6 10 8 7 7 10 7 7 6 8 7 8 9 6 11 7 6
 6 7 6 6 7 9 8 7 7 7 8 8 8 9 9 8 7 8 8 8
 8 6 6 9 9 6 7 8 6 8 9 7 8 5 7 8 5 7 9 9

*/
#define EXTDATA_VERSION "Ver. 2006-01-31"

#include "libk5.h"      // common header for IP-VLBI utilities

#ifdef WIN32
#define USE_ASM    // use inline assemble function
#endif

#include "libvssp32.h"

int main(int argc, char *argv[])
{
       int sfreq, adbit, numch;
       long int startoffset; // start time offset in sec
       long int smpl_count;    // sample number counts to extract
       long int counts;        //sample counter
       long int counts2;        //extract sample counter
       long int sofst_pos;    // start sample position from sec tic
       int nloop;
       int i,imax, m, k;
       int smode,usampl, omode;
       int bits, bytes, numb;
	   int nch;
       double fsampl,tsampl,fact;
	   double soffset, fsec, period;
       char fname[80],oname[80];
       char lab2[60], ltime1st[60];
       char labfsampl[10];
       char* dflt_fname="tds.data";
       char* dflt_oname="extdata.txt";
       K5VSSP_file_t K5;
       FILE *fo;

       if(argc == 1){
          printf("extdata %s\n",EXTDATA_VERSION);
          printf("Usage: extdata filename [ch [soffset [period [omode [outfile]]]]\n");
          printf("\n");
          printf("         where  filename ---- Data file name\n");
          printf("                             if 0 is given, tds.data will be used\n");
          printf("                ch   -------- Channel # to extract\n");
          printf("                             default is 1\n");         
          printf("                soffset --- Start time offset in sec (float seconds)\n");
          printf("                             default is 0.0\n");         
          printf("                period  --- Extracting period in sec (float seconds)\n");
          printf("                             default is 1.0\n");         
          printf("                omode   ---- out file mode  0: with header 1: without header\n");
          printf("                             default is 0\n");         
          printf("                outfile ---- Extract data outfile name\n");
          printf("                             default is extdata.txt\n");         
          exit(0);
       }

       /* data file name get */
       strcpy(fname,*(argv+1));
       if (fname[0]=='0'){
          strcpy(fname,dflt_fname);
       }
       strcpy(K5.fname,fname);

       /* Ch# to extract get */
       if (argc>=3)
       {
          nch = atoi(*(argv + 2 ));
       } else {
          nch=1;   
       }

       /* Start time offset get */
       if (argc>=4)
       {
          soffset = atof(*(argv + 3 ));
       } else {
          soffset=0.0;     
       }

       /* Period to extract get */
       if (argc>=5)
       {
          period = atof(*(argv + 4 ));
       } else {
          period=1.0;     
       }

       /* Output mode get */
       if (argc>=6)
       {
          omode = atoi(*(argv + 5 ));
       } else {
          omode=0;   
       }

       /* Out file name get */
       if (argc>=7)
       {
           strcpy(oname,*(argv+6));
       } else {
           strcpy(oname,dflt_oname);
       }

       /* Run condition monitor for debug*/
       //printf("Data File is %s\n",fname);
       //printf("nch, soffset, period  %d %f %f\n",nch,soffset,period);

       /* Program Name Display */
       printf("****************************************************\n");
       printf("*    IP-VLBI DATA EXTRACTION PROGRAM (extdata)     *\n");
       printf("*         %s    by  T.KONDO/NICT      *\n",EXTDATA_VERSION);
       printf("****************************************************\n");
       printf("\n");

       K5.size=get_file_size(K5.fname);
       /* Data file open */
       if( (K5.stream  = fopen( K5.fname, "rb" )) == NULL ){
           printf("Data File %s   Open Error! \n",K5.fname);
		   goto exitend2;
       }

       /* output file create */
       if( (fo  = fopen( oname, "w" )) == NULL )
       {
          printf("File  %s  Open Error! \n",oname);
          goto exitend3;
	   } 

       /* Data header check to get sampling parameters */
       if(CheckK5header_with_Read(&K5) < 0){
            goto exitend3;
       }

       /* parameter set */
        sfreq=K5.sfreq;
        adbit=K5.adbit;
        numch=K5.numch;
        fsampl=1000.0*(float)sfreq;   // sampling frequency (Hz)
        tsampl=1.0/fsampl;            // sampling period (sec)
        bits=((long)fsampl)*adbit*numch;  // # of bits in 1 sec data except header
        bytes=bits/8;                     // # of bytes in 1 sec data except header
        K5.fsample=(float)fsampl;

        /* Set extract Ch# to 1 in case of 1 ch board*/
        if(numch == 1) nch=1;    


        /* File read buffer size set */
        smode=1;                         // low resolution mode

        if(smode ==1){ usampl=10000; }
        else {
           usampl=50000;
           if(sfreq == 40){ usampl=40000; }
           if(sfreq == 100){ usampl=100000; }
           if(sfreq == 200){ usampl=200000; }
        }
        imax=(sfreq*1000)/usampl;
        numb=usampl*adbit*numch/8;   // # of bytes in unit # of samples
        K5.numb=usampl*K5.adbit*K5.numch/8;       // # of bytes in a usampl
        K5.imax=(K5.sfreq*1000)/usampl;        // # of usampls in a second

        //printf("imax numb  %d %d\n",imax,numb);    //debug

        K5.nword=K5.numb/4;                 // # of 32bit-word in a usampl
        K5.unitp=(double)usampl*K5.tsample;   // period in a usampl (sec)

        K5.ubuf  = (u_int32_t *)malloc(K5.nword*sizeof(u_int32_t)); // K5 data read buffer
        K5.idata  = (int *)malloc(32*K5.nword*sizeof(int)); // K5 data read buffer


        fact=((float)usampl)*((float)usampl);
        
        /* sampling frequency in text for print */
        if(sfreq == 40){strcpy(labfsampl,"40kHz"); }
        if(sfreq == 100){strcpy(labfsampl,"100kHz"); }
        if(sfreq == 200){strcpy(labfsampl,"200kHz"); }
        if(sfreq == 500){strcpy(labfsampl,"500kHz"); }
        if(sfreq == 1000){strcpy(labfsampl,"1MHz"); }
        if(sfreq == 2000){strcpy(labfsampl,"2MHz"); }
        if(sfreq == 4000){strcpy(labfsampl,"4MHz"); }
        if(sfreq == 8000){strcpy(labfsampl,"8MHz"); }
        if(sfreq == 16000){strcpy(labfsampl,"16MHz"); }
        if(sfreq == 32000){strcpy(labfsampl,"32MHz"); }
        if(sfreq == 64000){strcpy(labfsampl,"64MHz"); }

       /* Data extract start point set */ 
       startoffset=(long int)soffset;
       fsec=soffset-(double)startoffset;
       sofst_pos=(long int)(fsec/tsampl + 0.01);

       /* Data extraction period set */
       smpl_count=(long int)(period/tsampl + 0.01);

       /* Run condition display */

       //printf("startoffset, sofst_pos, smpl_count %d %d %d\n",startoffset,sofst_pos,smpl_count);
       printf("\n");
       printf("  Data File : %s",K5.fname);
       if(K5.format == 1){
          printf(" (K5/VSSP format)\n");
       } else if (K5.format == 2){
          printf(" (K5/VSSP32 format)\n");
       } else {
          printf("\n");
       }
       printf("  Sampling Freq : %s\n",labfsampl);
       printf("  A/D bits      : %d\n",adbit);
       printf("  Number of CHs : %d\n",numch);

       printf("  Extracted CH# : %d\n",nch);

       /* foward startffset seconds */
       if(fwdNsecK5(startoffset, &K5) <0){
           printf("Foward error %d\n",startoffset);
           goto exitend;
       }
       printf("  Time %02d:%02d:%02d   Sec in Day = %d\n",K5.hh,K5.mm,K5.ss,K5.seconds);
       sprintf(ltime1st,"Time(UT) %02d:%02d:%02d\0",K5.hh,K5.mm,K5.ss);
       strcpy(lab2,ltime1st);
        
       /* continue run info display */
       printf("  Start Time of Extraction : %02d:%02d:%02d.%08d\n",K5.hh,K5.mm,K5.ss,(long int)(fsec*1.0e8));
       printf("  Period (sec)             : %f\n",period);
       printf("  Out File : %s\n",oname);


       /* Data info out to out_file */
       if(omode == 0) {
          fprintf(fo,"**  Data File : %s",K5.fname);
          if(K5.format == 1){
               fprintf(fo," (K5/VSSP format)\n");
          } else if (K5.format == 2){
               fprintf(fo," (K5/VSSP32 format)\n");
          } else {
               fprintf(fo,"\n");
          }
          fprintf(fo,"**  Sampling Freq : %s\n",labfsampl);
          fprintf(fo,"**  A/D bits      : %d\n",adbit);
          fprintf(fo,"**  Number of CHs : %d\n",numch);
          fprintf(fo,"**  Extracted CH# : %d\n",nch);
          fprintf(fo,"**  Start Time of Data : %02d:%02d:%02d.%08d\n",K5.hh,K5.mm,K5.ss,(long int)(fsec*1.0e8));
          fprintf(fo,"**  Period (sec)       : %f\n",period);
       }
       
       /* Data extraction start */
	   counts=0;
	   counts2=0;
       m=nch-1;
       nloop=0;

       /* Data read loop start here */

loop1:
        if(nloop >0) {
           if(CheckK5header_with_Read(&K5) < 0) goto exitend; 
            printf("  Time %02d:%02d:%02d   Sec in Day = %d\n",K5.hh,K5.mm,K5.ss,K5.seconds);
        }

        for(i=0; i< K5.imax; i++){

             K5.wordread = fread(K5.ubuf, sizeof(u_int32_t), K5.nword, K5.stream);
             K5.pos+=K5.wordread*4;
             K5.vflag=1; // validiate data
             parseADdata_3N(&K5);
        	
             for(k=0; k<K5.npos/K5.numch; k++){
               	counts++;
               	if(counts > sofst_pos) { 
               		counts2++;
               		if(counts2 > smpl_count) goto exithere; 
               	    fprintf(fo," %d",K5.idata[k*numch+m]);
                    if ((counts2 % 20) == 0) fprintf(fo,"\n");
               	}
             }
       }
       nloop++;
       goto loop1;
exithere:
       fprintf(fo,"\n");
       printf("\n");
       printf("Data extraction finished.\n");
       i=fclose( fo ) ;

exitend: 
       
       free(K5.ubuf);
       free(K5.idata);

exitend3: 
       i=fclose( K5.stream ) ;

 exitend2: 

       return 0;
}
