/********************************************************************/
/*                                                                  */
/*   Program Name :  monit2                                         */
/*                                                                  */
/*      Version:  0.00  2006-02-04                                  */
/*                                                                  */
/*      Copyright (c) 2006 T.Kondo/NICT All Right Reserved          */
/*                                                                  */
/********************************************************************/
/*
 ho|ukah{[h̘A^pvO
         by T.Kondo 2006.02.03  start development (base is monit.c)   
                    2006.02.04  add occurrence time siries plot

     gp@  monit2 numch [sfreq adbit logfile] 
             numch ---- TvO`l 1 ܂ 4
                   sfreq  TvOg
                       0.04,0.1,0.2,0.5,1,2,4,8,16,32,64 (for MHz) (default is 1)
                      PF32,64K5/VSSP32̂
                      QF̒lŃZbgƁAK5/VSSP32ɂ
                         tB^[X[ɃZbg
                         ̒l̏ꍇAtB^[͈ȉ̂悤ɃZbg
                      Fsample(MHz)   0.04 0.1 0.2 0.5 1 2 4 8 16 32 64 
                      Ffilter(MHz)     2   2   2   2  2 2 2 4  8 16  0
                                                   (0̓X[Ӗj
                   adbit  `c\irbg)
                       1,2,4,8    (default is 8)
                   logfile -- Ot@C
                      ftHgmonit2.log
                      ftHg̃Ot@C͏㏑
                      [U[logfilep[^Ŏw肵Ot@Cɂ
                      O̓Ayh

*/
#define PROGRAM_VERSION "Ver. 2006-02-04"

#include "chead.h"      // common header for IP-VLBI utilities

#ifdef linux
  #include <stdint.h>  // necessary for handling uint32_t etc.
  #include <sys/ioctl.h>
  #ifdef _VSSP32
    #include <sys/tdsio.h>
    #include <sys/tdssdh.h>
  #else
    #include <linux/tdsio.h>
  #endif
#else 
  #include <sys/tdsio.h>  // IP-VLBI board header
#endif
//#include "libipvlbi.h"  // IP-VLBIp֐Q(by T.Kondo) 2005-06-12
#include "libipvlbi_board.h"  // IP-VLBITv[{[hp֐Q(by T.Kondo)

/* device driver file set  (added on 2005-12-20) */
#ifdef _VSSP32
  #define DEV_FILE "/dev/utds0"     // device file for K5/VSSP32
#else
  #define DEV_FILE "/dev/tds0"      // device file for K5/VSSP
#endif


/* set global variables */
char dev[] = DEV_FILE;  // IP-VLBI BOARD control variable
int fd_in;                 // IP-VLBI BOARD control variable
double telapsed;           // to measure processing time
double telongest, teshortest;  // for statistics
time_t tstart0,tnow0,tstart, tfinish;    //           "
time_t timeold;
//char* dflt_logdir=K5LOGDIRDFLT;        // default log file directory
char* dflt_logdir="./";        // default log file directory
char logdir[60];               // logfile directory
char hostname[20];             // host name
char lbuf[80];
logval_t lg;

/* set interrupt handler */
void Handler(int n);

void SetHandler(void)
{
    if(signal(SIGINT, Handler) == SIG_ERR){
        printf("Signal handler set up failure!\n");
        abort();
    }
}

void Handler(int n)
{
     static int x=0;
     int rv;
     printf("Interrupt occurred !!\n");

     /* sampling stop */

     rv = ioctl(fd_in, TDSIO_SAMPLING_STOP);
     if (rv == -1) {
     perror("stop sampling failed, anyway stop ");
     goto end;
     }
     else {
        printf("Stop sampling!\n");
     }

     //close(fd_out);

 end:
     tfinish= time(NULL);
     telapsed = difftime(tfinish,tstart);
     sprintf(lbuf,"monit2 stop sampling after %f minutes sampling.",telapsed/60.0);
     //if(LogWrite2(logdir,hostname,0,0.0,0,lbuf) == -1) printf("LogWrite2 error!\n");
     LogWrite4(&lg, 0, 0.0, 0, lbuf);
     close(fd_in);
     exit(0);
}

void occurrence_plot(int *noc, int nline, int col_max, int interval)
{
  /* Occurrence hist gram plot */
  int n,k;
  //int nline;
  int nmax;
  int kmax;
  //int col_max;
  double step;
  char iline[70];
  //nline=4;
  //col_max=50;
  
  // find max
  nmax=0;
  for(n=0; n<100; n++){
     if(noc[n] > nmax) nmax=noc[n];
  }
  step=(double)nmax/(double)nline;
  
  printf("          OCCURRENCE VS TIME (every %d minutes)  MAX=%d\n",interval,nmax);
  // each line data generate
  for(n=nline; n>0; n--){
      for(k=0; k<col_max; k++){
          kmax=k;
          if(noc[k]==-1){
              iline[k]='\0';
              break;
          }
          if((double)noc[k] > (double)(n-1)*step){
              iline[k]='*';
          } else {
              iline[k]=' ';
          }
      }
      iline[kmax+1]='\0';
      printf("   |%s|\n",iline);
  }
  
  for(k=0; k<col_max; k++) iline[k]='-';
  iline[col_max]='\0';
  printf("   +%s+\n",iline);
  printf("\033[1A");  // move cursol 1 lines up
  printf("   NOW-------->PAST(MAX:%d minutes)\n",interval*col_max);
}

//int sampleget_monit(char* outfile, int span, int sfreq, 
//                    int adbit, int numch, int filter, int adjust)
int sampleget_monit2(char* outfile, vssp_param_t *sp)
{
    //char outfile[] = "./tds.data";
    //char dev[] = "/dev/tds0";
    //int fd_in;
    int fd_out;
    mode_t ofilemode = S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH;
    int rv;
    unsigned int timen,day,sec; // foCXǂݍ񂾌݂̎i[
    unsigned int secold;
    int i,h,m,s;
    int n;
    int secforce;
    int ihist[4][8];
    int hmax[4];
    char iline[70];
    char* lev0="          ";
    char* lev1="*         ";
    char* lev2="**        ";
    char* lev3="***       ";
    char* lev4="****      ";
    char* lev5="*****     ";
    char* lev6="******    ";
    char* lev7="*******   ";
    char* lev8="********  ";
    char* lev9="********* ";
    char* lev10="**********";
    char* levd="<         ";
    char* levu="         >";
    int w1,w2,w3,mm;
    int beat;
    double sum[4],ave[4];
    int nave;
    char cbuf[20];
#ifdef _VSSP32
    struct tdsio tdsio;   // for setting DC_OFFSET or getting DC_OFFSET
#endif
    
    //int span, sfreq;
#ifdef _VSSP32
    int headbit=256;  // default header bit number  for K5/VSSP32
#else
    int headbit=64;  // header bit number  for K5/VSSP
#endif
    int allbyte;     // TvOoCg
    int bitsec;       // Pb̃rbgiwb_[܂ށj
    int bytesec;       // Pb̃oCgiwb_[܂ށj
    int c,k;
    int nkai;
    int err, adjusted;
    int dcoffset[4];
    int numerr; // error occurence number cpounter
    int noc[100];  // to store recent # of error occurred
    int noc_interval_minutes;  // interval in minutes
    int noc_carry; // flag 
    int col_max=60;
    int nline=4;
    //unsigned int sampling1, freq, width, stat;
    int sampling1, freq, width, stat, filter0;
    unsigned int ref, pps, rhz, pll;
    int ch, pos;
    u_int8_t sfreq_t, sbit_t, numch_t;
    u_int8_t sampling;
    //u_int32_t buf[BUFSIZ * 2];
    u_int32_t buf[1024 * 2];
    //double telapsed;           // to measure processing time   (move to groval area)
    //time_t tstart, tfinish;    //           "
    //printf("BUFSIZ   %d\n",BUFSIZ);   // BUFSIZ: 1024 for K5/VSSP   8192 for K5/VSSP32
    //int xdata[BUFSIZ * 16];  // f[^̃f[^[p
//    int xdata[1024 * 64];  // f[^̃f[^[p
    
    int nbyte = sizeof(buf);   // nbyte = 8192

    //printf(" span = %d\n",span);    // debug
    //printf(" sfreq= %d\n",sfreq);   // debug

    telongest=0.0;
    teshortest=0.0;
    numerr=0;
    adjusted=0;
    
    for(n=0; n<100; n++) noc[n]=-1;
    noc[0]=0;
    
    tstart0= time(NULL);
    timeold=tstart0;
    noc_carry=0;
    noc_interval_minutes=20;

loopmain:

    /* sampler open */
    fd_in = open(dev, O_RDONLY);
    //fd_in = open("/dev/tds0", O_RDONLY);
    if (fd_in == -1) {
        perror("device open() error ");
        return -1;
    }
    

#ifdef _VSSP32
    if((rv=ioctl(fd_in,TDSIO_INIT)) == -1) {
        perror("ioctl() INIT failed ");
        goto end;
    }
#endif
    /* board status check */
    if((rv=check_vssp(fd_in, &stat, 1)) == -1) {
        perror("ioctl() status get failed ");
        goto end;
    }

      
    /* output file open */
/*
    fd_out = open(outfile, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
    if (fd_out == -1) {
        perror("output file open() error");
        goto end;
    }
*/
    /* sampling parameters set */
    //if((rv=set_vssp_sparam(fd_in,sfreq,adbit,numch,filter,1))==-1){
    if((rv=set_vssp_sparam(fd_in,sp,1))==-1){
        printf("sampling set failed \n");
        goto end;
    }
    
    if (sp->sfreq >= 40) {
       bitsec=sp->sfreq*1000 + headbit ;
    } else { 
       bitsec=sp->sfreq*1000*1000 + headbit ;
    }

    bitsec=bitsec*sp->adbit*sp->numch;   // bit number per second

    allbyte= 2000000000;
/*
    bytesec=bitsec/8;
    allbyte=bytesec*span;
    if (allbyte > 2000000000){
       allbyte= 2000000000;
       secforce=allbyte/bytesec;
       printf(" # of bytes force to set to 2GB because it exceeds 2GB\n");  // debug
       printf(" Obserbasation span (sec) reduced to %d\n",secforce);  // debug
    }
    printf(" bitsec  = %d\n",bitsec);  // debug
    printf(" bytesec = %d\n",bytesec);  // debug
    printf(" allbyte = %d\n",allbyte);  // debug
*/
    /* get sampling parameters from a board */
    //if ((rv=get_vssp_sparam(fd_in,&freq,&width,&ch,&filter0,1))== -1) {
    if ((rv=get_vssp_sparam(fd_in,sp,1))== -1) {
        perror("ioctl() get sampling parameter failed ");
        goto end;
    } else {
        printf("sampling setting is %d kHz %d BIT %d CH",
                  sp->freqkhz,sp->adbit,sp->numch);
#ifdef _VSSP32
        printf(" FILTER %d MHz\n",sp->filter);
#else
        printf("\n");
#endif
    }   

    /* board time get */
 /*
    rv = ioctl(fd_in, TDSIO_GET_TIME, &timen);
    if (rv == -1) {
        perror("ioctl() time get failed ");
        return -1;
    }
       day=TDS_GET_DAYS(timen);
       sec=TDS_GET_SEC(timen);
       sec2hms(sec,&h,&m,&s);
    //printf("get count day from device [%5d]\n",TDS_GET_DAYS(timen));
    //printf("get count sec from device [%5d]\n",TDS_GET_SEC(timen));
    printf("%03d %02d:%02d:%02d\n",day,h,m,s);
 */

       
    rv = ioctl(fd_in, TDSIO_BUFFER_CLEAR);   // {[hFIFÕNA[
    if (rv == -1) {
        perror("ioctl() FIFO clear failed ");
        goto end;
    } else {
        printf("ioctl() FIFO clear succeed\n");
    }

    rv = ioctl(fd_in, TDSIO_SAMPLING_START);
    if (rv == -1) {
        perror("ioctl() start sampling failed ");
              printf("Probably time was not set for the IP-VLBI board.\n");
              printf("Please set time using timesettk and try again.\n");
        goto end;
    } else {
        printf("ioctl() start sampling succeed\n");
    }
#ifdef _VSSP32
    sprintf(lbuf,"monit2 sampling start : %d kHz (filter %d MHz) %d BIT %d CH",
                        sp->freqkhz,sp->filter,sp->adbit,sp->numch);
#else
    sprintf(cbuf,"monit2 sampling start : %d kHz %d BIT %d CH",
                        sp->freqkhz,sp->adbit,sp->numch);
#endif
    //if(LogWrite2(logdir,hostname,0,0.0,0,lbuf) == -1) printf("LogWrite2 error!\n");
    LogWrite4(&lg, 0, 0.0, 0, lbuf);
    
    
    tstart= time(NULL);

  /* MONITOR START */
  
    printf("\033[2J");   //  Erase the screen ( move the cursor to home ) for VT100
    printf("\033[H");   //  move the cursor to home
    printf("********************************************************************\n");
    printf("*                                                                  *\n");
    printf("*   MONIT2 (sampling reliability test for K5/VSSP or K5/VSSP32)    *\n");
    printf("*                        (%s)                         *\n",PROGRAM_VERSION);
    //printf("*                             by                                   *\n");
    printf("*                       T.Kondo/NICT                               *\n");
    printf("*                                                                  *\n");
    printf("*                        CTRL C  for STOP                          *\n");
    printf("*                                                                  *\n");
    printf("*******T***********************************************KONDO********\n");
    //printf("\n");
    printf("     log file            : %s\n",lg.logfile);
    printf("     sampling parameters : %d kHz (filter %d MHz) %d BIT %d CH\n",
                         sp->freqkhz,sp->filter,sp->adbit,sp->numch);
    //printf("\n");
    printf("     number of error occurence is %d\n",numerr);
    if(numerr !=0){
       printf("          shortest period (minutes) = %f\n",teshortest/60.0);
       printf("          longest  period (minutes) = %f\n",telongest/60.0);
    }
    printf("\n");
    
    c = 0;

    beat=0;
    nave=0;
    nkai=0;
    //while (c < BUFSIZ * BUFSIZ) {
    while (c <=  allbyte) {      // loop until CTRL-C
       rv = read(fd_in, buf, nbyte);
       if (rv == -1) {
          printf("read() failed   ");
          ioctl(fd_in, TDSIO_GET_ERROR, &err); printf("Error code = %d\n",err);  // debug for VSSP32
          tfinish= time(NULL);
          telapsed = difftime(tfinish,tstart);
          printf("error occurred after %f minutes sampling.\n",telapsed/60.0);
          sprintf(lbuf,"monit2 error (%d) occurred after %f minutes sampling.",err,telapsed/60.0);
          //if(LogWrite2(logdir,hostname,0,0.0,0,lbuf) == -1) printf("LogWrite2 error!\n");
          LogWrite4(&lg, 0, 0.0, 1, lbuf);
          if(numerr==0){
              telongest=telapsed;
              teshortest=telapsed;
          }
          if(telapsed < teshortest) teshortest=telapsed;
          if(telapsed > telongest) telongest=telapsed;
          numerr++;
          noc[0]++;
          //goto end;
          close(fd_in);
          goto loopmain;  // do again  
       }

       //if((c != 1) && (c !=0)){ goto bypass1;}

//       parseADdata(buf, rv, sp->adbit, xdata, &pos);
       /* Histgram Statistics */
/*
       w3=0;
       for(k=0; k<pos; k++){
          w1=xdata[k];
          if(sp->adbit == 8) w2=w1/32; 
          if(sp->adbit == 4) w2=w1/2; 
          if(sp->adbit == 2) w2=w1;
          if(sp->adbit == 1) w2=w1;
          ihist[w3][w2]+=1;
          sum[w3]+=(double)w1;  // for average calc
          w3++;
          if( w3 == 4 ) w3 =0; 
          if( sp->numch == 1 ) w3 =0; 
       }
       nave=pos/sp->numch;
       for(k=0; k<sp->numch; k++) ave[k]=sum[k]/(double)nave - 255.0/2.0;  // assuming 8bit AD
*/
       if((c != 1) && (c !=0)) goto bypass1;  // to reduce the refresh rate

       //if(c !=0 ) printf("\033[10A");  // move cursol 10 lines up
       //if(c !=0 ) printf("\033[1A");  // move cursol 1 lines up
       if(c !=0 ) printf("\033[8A");  // move cursol 8 lines up
       
       tnow0= time(NULL);
       telapsed = difftime(tnow0,tstart0);
       /* heart beat */
       if(beat == 0) printf("  sampling going on  *     time(minutes) since start : %f\n",telapsed/60.0);
       if(beat == 1) printf("  sampling going on   *\n");
       beat++;
       if(beat==2) beat=0;
       
       telapsed = difftime(tnow0,timeold);
       if(telapsed >= noc_interval_minutes*60.0){
           noc_carry=1;
           timeold=tnow0;
       }
       /* Histgram occurrence shift by one */
       if(noc_carry==1){
          for(n=99; n>0; n--){
             noc[n]=noc[n-1];
          }
          noc[0]=0;
          noc_carry=0;
       }
       
       /* Histgram occurrence Plot */
       printf("\n");
       occurrence_plot(noc, nline, col_max, noc_interval_minutes);

       bypass1:  ;
       
       /* histgram data initialize */
       for(w1=0; w1<4; w1++){
           for(k=0; k<8; k++){
              ihist[w1][k]=0;
           }
           sum[w1]=0.0;
           ave[w1]=0.0;
       }
       nave=0;
       //printf(" nbyte = %d\n",nbyte);   // debug
       // rv = write(fd_out, buf, rv);
       //c= c+ nbyte;
       c++;
       //printf("c=%d\n", c); printf("\033[10A"); // debug
       if(c == 40*sp->numch ) {
          c=1;
          nkai++;
          if(nkai == 3){
              nkai=0;
//              if(adjust==1) break;  // exit while loop
          }
       }
    }


    rv = ioctl(fd_in, TDSIO_SAMPLING_STOP);
    if (rv == -1) {
        perror("ioctl() stop sampling failed ");
        goto end;
    }
    else {
        printf("ioctl() stop sampling succeed\n");
    }
       
/*
    close(fd_out);
*/
       /* board time get */
/*
    rv = ioctl(fd_in, TDSIO_GET_TIME, &timen);
    if (rv == -1) {
        perror("ioctl() time get failed ");
        return -1;
    }
       day=TDS_GET_DAYS(timen);
       sec=TDS_GET_SEC(timen);
       sec2hms(sec,&h,&m,&s);
    //printf("get count day from device [%5d]\n",TDS_GET_DAYS(timen));
    //printf("get count sec from device [%5d]\n",TDS_GET_SEC(timen));
    printf("%03d %02d:%02d:%02d\n",day,h,m,s);
*/

 end:
    close(fd_in);

    return rv;
}


int main(int argc, char **argv)
{
    //char dev[] = "/dev/tds0";
    char outfile[] = "./tds.data";
    char cbuf[20];
    char logfile[80];
    char* dflt_logfile="monit2.log";
    int rv;
    int span, sfreq, adbit, numch, filter, adjust;
    int no_filter;
    int logmode;
    double freq;
    vssp_param_t sp;

    if(argc <= 1 ){
        printf("Usage: monit numch [AUTO|ZERO]\n");
          printf("Usage: monit2 numch [sfreq [adbit [logfile]]]\n");
          printf("\n");
          printf("         where  numch ---- number of channel\n");
          printf("                           1 | 4\n");
#ifdef _VSSP32
          printf("                sfreq ---- sampling frequency\n");
          printf("                           0.04,0.1,0.2,0.5,1,2,4,8,16,32,64 (for MHz)\n");
          printf("                               (default is 1)\n");
          printf("                     Note1: 32 and 64 are valid only for K5/VSSP32\n");
          printf("                     Note2: -VE means ""no use of digital filter"" at K5/VSSP32\n");
          printf("                            In case of +VE, relation between sampling frequency\n");
          printf("                            (Fs) and filter frequency(Ff) is as follows;\n");
          printf("                            Fs(MHz)   0.04 0.1 0.2 0.5 1 2 4 8 16 32 64\n");
          printf("                            Ff(MHz)     2   2   2   2  2 2 2 4  8 16  0\n");
          printf("                                   (valid for K5/VSSP32. 0 means through)\n");
#else
          printf("                sfreq ---- sampling frequency\n");
          printf("                           0.04,0.1,0.2,0.5,1,2,4,8,16 (for MHz)\n");
          printf("                               (default is 1)\n");
#endif
          printf("                adbit ---- A/D bit\n");
          printf("                           1|2|4|8\n");
          printf("                          default is 8\n");
          printf("                logfile ---- log out file name\n");
          printf("                          default is monit2.log\n");
          printf("                          if default logfile is used, it is overwritten.\n");
          printf("                          But if logfile is set by ""logfile"" parameter,\n");
          printf("                          log will be appended to logfile.\n");
        exit(0);
    }

       
    sp.numch = atoi(*(argv + 1 ));
    if(sp.numch != 1) {sp.numch=4;}
    no_filter=0;
    if (argc>=3){
        freq= atof(*(argv + 2 ));
        if(freq < 0.0) {
           freq=-freq;
           no_filter=1;
        }
        sfreq=(int)freq;
        if(sfreq==0) sfreq=(int)(freq*1000.0);
    } else {
        sfreq=1;
        no_filter=1;
    }
    sp.filter=2;   // default is minimum settable filter frequency (MHz)
    if(sfreq==4) sp.filter=2;
    if(sfreq==8) sp.filter=4;
    if(sfreq==16) sp.filter=8;
    if(sfreq==32) sp.filter=16;
    if(sfreq==64) sp.filter=0;
    if(no_filter==1) sp.filter=0;
    sp.sfreq=sfreq;
    
    if (argc>=4){
       sp.adbit = atoi(*(argv + 3 ));
    } else {
       sp.adbit=8;
    }
    
    logmode=0;  // log file is first cleared
    if (argc>=5){
          strcpy(logfile,*(argv+4));
          logmode=1; // log is appended to existed log file
    } else {
          strcpy(logfile,dflt_logfile);
    }
    

    
    
    //span=100;
    //sp.sfreq=1;
    //sp.adbit = 8;
    //sp.filter=0;  // K5/VSSP32 parameter
    /* get host name */
    hostget(hostname);
    /* log info set if necessary */
    strcpy(lg.logfile,logfile);
    lg.hostname[0]='\0';
    lg.logdir[0]='\0';
    //lg.logfiletype=-1;    //-1: no log   0: log out
    lg.logfiletype=0;    //-1: no log   0: log out
/*
    printf(" span = %d\n",span);    // debug
    printf(" sfreq= %d\n",sfreq);   // debug
    printf(" adbit= %d\n",adbit);   // debug
    printf(" numch= %d\n",numch);   // debug
*/
    printf("*******************************************\n");
    printf("*  K5/VSSP (IP-VLBI) board sampling test  *\n");
    printf("*          MONIT2 (%s)       *\n",PROGRAM_VERSION);
    printf("*                by                       *\n");
    printf("*           T.Kondo/NICT                  *\n");
    printf("*******************************************\n");
    printf(" \n");

    SetHandler();
#ifdef _VSSP32
    sprintf(lbuf,"monit2(%s) start for K5/VSSP32 on %s",PROGRAM_VERSION,hostname);
#else
    sprintf(lbuf,"monit2(%s) start for K5/VSSP32 on %s",PROGRAM_VERSION,hostname);
#endif
    //if(LogWrite2(logdir,hostname,0,0.0,0,lbuf) == -1) printf("LogWrite2 error!\n");
    LogWrite4(&lg, 0, 0.0, 0, lbuf);
    //rv=sampleget_monit(outfile, span, sfreq, adbit, numch, filter, adjust);
    rv=sampleget_monit2(outfile, &sp);


    return 0;
}
