/********************************************************************/
/*                                                                  */
/*   Program Name :  sampling2                                      */
/*                                                                  */
/*      Version:  0.00  2002-05-26                                  */
/*                1.00  2002-10-04                                  */
/*                1.01  2005-06-12                                  */
/*                2.00  2005-12-28  support VSSP32                  */
/*                2.01  2006-01-02  minor change                    */
/*                                                                  */
/*      Copyright (c) 2002-2006 T.Kondo/NICT All Right Reserved     */
/*                                                                  */
/********************************************************************/
/*

 ho|ukah ItCTvOvO
        iZbg͕ʂ̃\tgōs)
         by T.Kondo 2001.8.17
                    2002.5.26
                    2002.9.15  PbƂ̃f[^ǉ
                    2002.10.04  Ver 1.0 release
                    2005.06.12  minor change
                    2005-12-21  support VSSP32
                    
    点 sampling2 span sfreq adbit numch [filename [tempdir [mode]]] 
          span   Wԁibj
                sfreq  TvOg
                       40,100,200,500  (kHz)    <= this is to keep backward compatibility
                       0.04,0.1,0.2,0.5  (MHz)
                       0.04,0.1,0.2,0.5,1,2,4,8,16,32,64 (for MHz)
                   PF32,64K5/VSSP32̂
                   QF̒lŃZbgƁAK5/VSSP32ɂ
                         tB^[X[ɃZbg
                         ̒l̏ꍇAtB^[͈ȉ̂悤ɃZbg
                      Fsample(MHz)   0.04 0.1 0.2 0.5 1 2 4 8 16 32 64 
                      Ffilter(MHz)     2   2   2   2  2 2 2 4  8 16  0
                                                   (0̓X[Ӗj
                adbit  `c\irbg)
                       1,2,4,8 
                numch  `l
                       1 ܂ 4
                filename -- f[^t@C
                      ftHgtds.data
                tempdir -- Pbf[^t@CfBNg
                      ftHg̓JgfBg
                mode    -- t@Co̓[h
                       1: ꊇt@Ĉ iftHgj
                       2: Pbf[^t@Ĉ
                       3:  ꊇt@C{Pbƃt@C
                       4:  Pbf[^t@CóAϑꊇt@C쐬
                       6: Pbf[^t@Ĉ (Ԑj
                       7: UƓit@Co͖jVXe`FbNp
*/
#define  SAMPLING2_VERSION "Ver. 2006-01-02"
#include "chead.h"      // common header for IP-VLBI utilities

//#include "libipvlbi.h"  // IP-VLBIp֐Q(by T.Kondo)
//#include "libipvlbi_board.h"  // IP-VLBITv[{[hp֐Q(by T.Kondo)
/* 2005-06-12 */
#include "libipvlbi.c"  // IP-VLBIp֐Q(by T.Kondo)
#include "libipvlbi_board.c"  // IP-VLBITv[{[hp֐Q(by T.Kondo)



int main(int argc, char **argv)
{
    char outfile[80];
    char* dflt_fname="tds.data";
    char* dflt_tempdir="./";
    char outdir[60];
    int i,rv, mode;
    int span, sfreq, adbit, numch;
    int no_filter;
    double freq;
    spget_t spg;  //2005-12-28

    if(argc < 3){
          printf("Sampling2 %s\n",SAMPLING2_VERSION);
          printf("Usage: sampling2 span sfreq adbit numch [filename [tempdir [mode]]]\n");
          printf("\n");
          printf("         where  span ---- duration (sec)\n");
#ifdef _VSSP32
          printf("                sfreq ---- sampling frequency\n");
          printf("                           40,100,200,500 (for kHz)\n");
          printf("                           0.04,0.1,0.2,0.5,1,2,4,8,16,32,64 (for MHz)\n");
          printf("                     Note1: 32 and 64 are valid only for K5/VSSP32\n");
          printf("                     Note2: -VE means ""no use of digital filter"" at K5/VSSP32\n");
          printf("                            In case of +VE, relation between sampling frequency\n");
          printf("                            (Fs) and filter frequency(Ff) is as follows;\n");
          printf("                            Fs(MHz)   0.04 0.1 0.2 0.5 1 2 4 8 16 32 64\n");
          printf("                            Ff(MHz)     2   2   2   2  2 2 2 4  8 16  0\n");
          printf("                                   (valid for K5/VSSP32. 0 means through)\n");
#else
          printf("                sfreq ---- sampling frequency\n");
          printf("                           40,100,200,500 (for kHz)\n");
          printf("                           1,2,4,8,16 (for MHz)\n");
#endif
          printf("                adbit ---- A/D bit\n");
          printf("                           1,2,4,8\n");
          printf("                          default is 1\n");
          printf("                numch ---- number of channel\n");
          printf("                           1,4\n");
          printf("                          default is 1\n");
          printf("                filename ---- out file name\n");
          printf("                          default is tds.data\n");
          printf("                tempdir ---- every 1sec data out directory\n");
          printf("                          default is current directory\n");
          printf("                mode  ---- File out mode\n");
          printf("                          1: One big file only (default)\n");
          printf("                          2: Every 1 sec file only\n");
          printf("                          3: One big file + Every 1 sec file (simultaneously)\n");
          printf("                          4: Every 1 sec file, after Obs one big file created\n");
          printf("                          5: 3 + 4 for debug purpose (debug.dat will be created)\n");
          printf("                          6: Every 1 sec file out only but no time limitation");
          printf("                             (continuous running with ring file buffer\n");
          printf("                                 (max 10 files))\n");
          printf("                          7: same as 6 but no file out\n");
          printf("                             (performance check purpose)\n");
          exit(0);
    }

    spg.sp.vsspaux.fmt=2;  // default AUX field format for K5/VSSP32  (sampling)
    span = atoi(*(argv + 1 ));
    //sfreq= atoi(*(argv + 2 ));
    freq= atof(*(argv + 2 ));
    no_filter=0;
    if(freq < 0.0) {
      freq=-freq;
      no_filter=1;
    }
    sfreq=(int)freq;
    if(sfreq==0) sfreq=(int)(freq*1000.0);
    // filter frequency set
    spg.sp.filter=2;   // default is minimum settable filter frequency (MHz)
    if(sfreq==4) spg.sp.filter=2;
    if(sfreq==8) spg.sp.filter=4;
    if(sfreq==16) spg.sp.filter=8;
    if(sfreq==32) spg.sp.filter=16;
    if(sfreq==64) spg.sp.filter=0;
    if(no_filter==1) spg.sp.filter=0;

    if (argc>=4) {
        adbit = atoi(*(argv + 3 ));
    } else {
        adbit=1;
    }

    if (argc>=5) {
        numch = atoi(*(argv + 4 ));
    } else {
        numch=1;
    }

    if (argc>=6) {
        strcpy(outfile,*(argv+5));
    } else {
        strcpy(outfile,dflt_fname);
    }
    
    if (argc>=7){
        strcpy(outdir,*(argv+6));
    } else {
        strcpy(outdir,dflt_tempdir);
    }
    /* check out dir name accompanied by "/" or not */
    i=strlen(outdir);
    //printf("i= %d\n",i);
    if(outdir[i-1] != '/') {
        outdir[i]='/';
        outdir[i+1]='\0';
    }
    
    if (argc>=8) {
        mode = atoi(*(argv + 7 ));
    } else {
        mode=1;
    }

    printf(" span    = %d\n",span);    // debug
#ifdef _VSSP32
    printf(" sfreq   = %d (freq(MHz) = %f)\n",sfreq,freq);   // debug
    if(spg.sp.filter==0){
       printf(" filter  = through\n");   // debug
    } else {
       printf(" filter  = %d (MHz)\n",spg.sp.filter);   // debug
    }
#else
    printf(" sfreq   = %d\n",sfreq);   // debug
#endif
    printf(" adbit   = %d\n",adbit);   // debug
    printf(" numch   = %d\n",numch);   // debug
    printf(" outfile = %s\n",outfile);   // debug
    
#ifdef _VSSP32
    /* prepare AUX field for K5/VSSP32 */
    /* get host name for AUX filed */
    
    hostget(spg.sp.vsspaux.hostname8);
    strcpy(spg.sp.vsspaux.sid," ");
    strcpy(spg.sp.vsspaux.sid2,"  ");
    strcpy(spg.sp.vsspaux.station8,"sampling");
    spg.sp.vsspaux.size=20;  // this is fixed
    spg.sp.vsspaux.filter=spg.sp.filter;
    vssp_aux_make(&spg.sp.vsspaux);
#endif

    spg.span=span;
    spg.sp.sfreq=sfreq;
    spg.sp.adbit=adbit;
    spg.sp.numch=numch;
    strcpy(spg.outfile,outfile);
    strcpy(spg.outdir,outdir);

    //rv=sampleget4(outfile, span, sfreq, adbit, numch, outdir, mode);
    rv=sampleget4(&spg, mode);

    if(mode==1 || mode==3 || mode==4) {
       printf("Data File is %s\n",outfile);
    }
    if(mode==2 || mode==3 || mode==4) {
       printf("1sec Data out directory is %s\n",outdir);
    }
    

    return 0;
}
