/*******************************************************************/
/*                                                                 */
/*   Program Name :  skdchk                                        */
/*                                                                 */
/*      Version:  2.01  2005-06-12                                 */
/*                                                                 */
/*      Copyright (c) 2002-2005 T.Kondo/CRL All Right Reserved     */
/*                                                                 */
/*******************************************************************/
/*

  Schedule File Read and Check  
            2002-06-02 
            by T. Kondo

    点 skdchk sked_file
         sked_file ---- XPW[t@C

Ver 2.01 2005.06.12  update due to update in common header name
2005-01-12  support VEX file
2003-08-08
   TulbgɑΉBeǖ̕KvfBXNTCYvZ

../sked/jd0306.skd
../sked/gg057c.vex
*/
#define SKDCHK_VERSION "Ver 2.01    2005-06-12"
#include "libk5.h"

int main(int argc, char *argv[])
{
      //char* fname="ge154.skd";
      sked_data_t skd;
      //struct schedule skd;
      double totsec, a, b, c;
      double totsec_by_sta[20];
      int i, k, smax, imax;
      int vexmode;  // 0: normal schedule file    1: VEX file  2005-01-12
      int kid;
      char stat_id[4];  // 2005-01-12
      vex_t vex;    // 2005-01-12

      if(argc == 1){
          printf("\n");
          printf("skdchk %s\n",SKDCHK_VERSION);
          printf("Usage: skdchk sked_file\n");
          printf("\n");
          printf("         where  sked_file ---- schedule file name\n");
          printf("                               (VEX file is supported)\n");
          exit(0);
      }

       printf("skdchk %s\n",SKDCHK_VERSION);
       strcpy(skd.skdname,argv[1]);  
       printf("Schedule file is  %s\n",skd.skdname);

       /* schedule file format check original SKED or VEX or OVEX */
       vexmode=0;
       check_sked_type(skd.skdname,skd.skedtype);
       
       if((strncmp(skd.skedtype,"VEX",3)==0) ||
           (strncmp(skd.skedtype,"OVEX",4)==0)) {    /* VEX or OVEX format*/
           printf("File type is VEX\n");
          vexmode=1;
          strcpy(vex.vex_file_name,skd.skdname);
          vex.neop=0;   /* initialize for no EOP data case*/
          vex_read(&vex);
          //SKED_mon(&vex);    //debug
          //FREQ_mon(&vex);    //debug
          //CLOCK_mon(&vex);  //debug
          //STATION_mon(&vex);  //debug
          stat_id[0]='\0';
          vex2sked3(&vex, stat_id, &skd);

          /* slect station  */

          printf(" ****** STATION ID TABLE *********\n");
          for (i=0; i<skd.nstation ; i++){
                 printf("  %s --- %s\n",skd.statid[i],skd.statnam[i]);
          }
          printf(" *********************************\n");
          printf(" Enter Station ID ----> ");
          scanf("%s",&stat_id);
          printf(" Selected station_id is %s\n",stat_id);

          // setup sked data again using given stat_id
          //vex2sked3(&vex, stat_id, &skd);

          /* Pick up scans where given_station ID is included */
          pickup_skd(&skd, stat_id);

       } else {                                   /* SKED format */
          readskd(&skd);
       }
       if(vexmode==1){
           // find index corresponding to stat_id 
            // get ID number for stat_id
            kid=0;
            for(k=0; k<skd.nstation; k++){
                if(strncmp(skd.statid[k],stat_id,strlen(stat_id))==0){
                    kid=k;
                    break;
                }
            }
       }

       //readskd(&skd);

       printf("\n");
       printf("*** SCHEDULE FILE (%s) INFORMATION ***\n",skd.skdname);
       printf("Experiment code    : %s\n",skd.expcode);
       printf("Number of stations : %d\n",skd.nstation);


       for(i=0; i < skd.nstation; i++){
           printf("  %3d %2s %10s %10f %10f %10f\n",i+1,skd.statid[i],skd.statnam[i],
                         skd.xyz[i][0],skd.xyz[i][1],skd.xyz[i][2]);
       }
       printf("Number of stars : %d\n",skd.nstar);

       if(skd.nstar > 20) {
          imax=20;
          printf("   (only 20 stars are listed here)\n");
       } else {
          imax=skd.nstar;
       }

       for(i=0; i < imax; i++)
       {
           printf("  %3d %10s %10s %10f %10f %10f\n",i+1,skd.starnam1[i],skd.starnam2[i],
                         skd.ra[i],skd.dec[i],skd.epo[i]);
       }
       if(vexmode==1){
           printf("Number of observations for %10s: %d\n",skd.statnam[kid],skd.nobs);
       } else {
           printf("Number of observations : %d\n",skd.nobs);
       }
       printf("   First 5 observations are as follows:\n");
       for (i=0; i < 5; i++)
       {
          printf("    %4d %10s %2d/%03d %02d:%02d:%02d  %3d %s\n",i+1,skd.obsstar[i],
                   skd.start[i][0],skd.start[i][1],skd.start[i][2],
                   skd.start[i][3],skd.start[i][4],skd.dura[i],skd.obsid[i]);
          //printf(" %d\n",strlen(skd.obsid[i]));
       }

       printf("   Last 5 observations are as follows:\n");
       for (i=skd.nobs-5; i < skd.nobs; i++)
       {
          printf("    %4d %10s %2d/%03d %02d:%02d:%02d  %3d %s\n",i+1,skd.obsstar[i],
                 skd.start[i][0],skd.start[i][1],skd.start[i][2],
                 skd.start[i][3],skd.start[i][4],skd.dura[i],skd.obsid[i]);
       }

       /* Disk requirement check */
       totsec=0.0;
       for(k=0; k<skd.nstation; k++) totsec_by_sta[k]=0.0;


       for(i=0; i< skd.nobs; i++){
           if(vexmode==1){
              totsec += (double)skd.datastop[i][kid];
           } else {
              totsec += (double)skd.dura[i];
           }
           for(k=0; k<skd.nstation; k++){
              totsec_by_sta[k]+= (double)skd.datastop[i][k];
           }
       }
       a=totsec*32.0e6;  // total bit  in case of 32Mbps
       b=totsec*64.0e6;  // total bit  in case of 64Mbps
       c=totsec*128.0e6;  // total bit  in case of 128Mbps
       a /= 8.0e9;   // in Gbytes
       b /= 8.0e9;   // in Gbytes
       c /= 8.0e9;   // in Gbytes
       printf("\n");
       if(vexmode==1){
           printf("    Disk requirements for %10s\n",skd.statnam[kid]);
       } else {
           printf("    Maximum Disk requirements\n");
       }
       printf("      Total observation time (sec)  = %d\n",(int)totsec);
       printf("       Disk requirements\n");
       //printf("          %10f GBytes for  32Mbps rate \n",a);
       //printf("          %10f GBytes for  64Mbps rate \n",b);
       //printf("          %10f GBytes for 128Mbps rate \n",c);
       printf("           32Mbps  : %10.3f GBytes\n",a);
       printf("           64Mbps  : %10.3f GBytes\n",b);
       printf("          128Mbps  : %10.3f GBytes\n",c);

       if(vexmode==1) goto bypass;
       printf("\n");
       smax=7;
       if(skd.nstation < smax) smax=skd.nstation;
       printf("        Disk Requirements by Station (GBytes)\n");
       for(k=0; k<78; k++) printf("="); printf("\n");
       printf("        ");
       for(k=0; k<smax; k++) printf("%10s",skd.statnam[k]); printf("\n");
       for(k=0; k<78; k++) printf("-"); printf("\n");
       printf("    sec ");
       for(k=0; k<smax; k++) printf("%10d",(int)totsec_by_sta[k]); printf("\n");
       printf(" 32Mbps ");
       for(k=0; k<smax; k++) printf("%10.1f",totsec_by_sta[k]*4e-3); printf("\n");
       printf(" 64Mbps ");
       for(k=0; k<smax; k++) printf("%10.1f",totsec_by_sta[k]*8e-3); printf("\n");
       printf("128Mbps ");
       for(k=0; k<smax; k++) printf("%10.1f",totsec_by_sta[k]*16e-3); printf("\n");
       for(k=0; k<78; k++) printf("="); printf("\n");

       if(skd.nstation > smax) {
          i=smax;
          smax=skd.nstation;
          printf("\n");
          printf("        Disk Requirements by Station (GBytes)\n");
          for(k=0; k<78; k++) printf("="); printf("\n");
          printf("        ");
          for(k=i; k<smax; k++) printf("%10s",skd.statnam[k]); printf("\n");
          for(k=0; k<78; k++) printf("-"); printf("\n");
          printf("    sec ");
          for(k=i; k<smax; k++) printf("%10d",(int)totsec_by_sta[k]); printf("\n");
          printf(" 32Mbps ");
          for(k=i; k<smax; k++) printf("%10.1f",totsec_by_sta[k]*4e-3); printf("\n");
          printf(" 64Mbps ");
          for(k=i; k<smax; k++) printf("%10.1f",totsec_by_sta[k]*8e-3); printf("\n");
          printf("128Mbps ");
          for(k=i; k<smax; k++) printf("%10.1f",totsec_by_sta[k]*16e-3); printf("\n");
          for(k=0; k<78; k++) printf("="); printf("\n");
       }

bypass:

       if(!system(NULL)) {  // command processor not implemwnted
          return 0;
       }
#ifndef WIN32
       /* Display Disk avilable size */
       printf("\n");
       printf("Disk mounted on your system is as follows:\n");
       printf("\n");
       system("df");
       printf("\n");
#endif

    return 0;
}
