/*******************************************************************/
/*                                                                 */
/*   Program Name :  timesync                                      */
/*                                                                 */
/*      Version:  0.00  2002-07-01                                 */
/*                1.00  2002-10-04                                 */
/*                1.10  2003-06-17  add log out                    */
/*                1.11  2003-07-20  add env variable monitor       */
/*                1.12  2005-06-12  minor update                   */
/*                2.00  2005-12-29  support VSSP32                 */
/*                                                                 */
/*      Copyright (c) 2002-2005 T.Kondo/NICT All Right Reserved    */
/*                                                                 */
/*******************************************************************/
/*

 ho|ukah{[h  PoorvO
        iZbg͕ʂ̃\tgōsj
         by T.Kondo 2002.7.1

    点 timesync [period]
          period  \鎞ԁibj
                       ftHg͂PObԕ\

 2005-12-20  support VSSP32
 2003/06/17  Ver 1.10 Oo͂ǉ

*/
#define TIMESYNC_VERSION "Ver. 2005-12-29"

#include "chead.h"      // common header for IP-VLBI utilities

//#include "libipvlbi.h"  // IP-VLBIp֐Q(by T.Kondo)
//#include "libipvlbi_board.h"  // IP-VLBITv[{[hp֐Q(by T.Kondo)
/* 2005-06-12 */
#include "libipvlbi.c"  // IP-VLBIp֐Q(by T.Kondo)
#include "libipvlbi_board.c"  // IP-VLBITv[{[hp֐Q(by T.Kondo)

#define K5LOGDIR  "K5LOGDIR"  // environment default for log out directry
#define K5LOGDIRDFLT  "./"    // default log file directory

int main(int argc, char **argv)
{
    int fd_in,rv;
    unsigned int time,day,sec; // foCXǂݍ񂾌݂̎i[
    unsigned int secold, secmax;
    int  yyyy, mm, dd;      // Ԑݒ(timeset)ŗp
    int  h, m, s;           // Ԑݒ(timeset)ŗp
    int  y3; // 7 bits year  (0-127)
    int counter;
    int i;
    char* dflt_logdir=K5LOGDIRDFLT;        // default log file directory
    char logdir[60];               // logfile directory
    char hostname[20];             // host name
    char cbuf[80];
    
    if (argc>=2){
         if(strncmp(*(argv+1),"env",3)==0){
           printf("   Enviroment variables\n");
           printf("        %s ---   default log file directory\n",K5LOGDIR);
           printf("                      ( %s )",getenv(K5LOGDIR));
           if(getenv(K5LOGDIR)==NULL) {
              printf(",  program deflt is ( %s )\n",K5LOGDIRDFLT);
           } else {
              printf("\n");
           }
           printf("\n");
           exit(0);
         } 
    } 

    if(argc >= 2){
       secmax = atoi(*(argv + 1 ));
       if(secmax <= 0) secmax=10;
    } else {
          secmax=10;
    }

    /* log directory name get from enviroment variable K5LOGDIR if it is set */
    if(getenv(K5LOGDIR) != NULL){
        strcpy(logdir,getenv(K5LOGDIR));
    } else {
        strcpy(logdir,dflt_logdir);
    }

    /* get host name */
    hostget(hostname);

    sprintf(cbuf,"timesync %s",TIMESYNC_VERSION);
    if(LogWrite2(logdir,hostname,0,0.0,0,cbuf) == -1) printf("LogWrite2 error!\n");

    //fd_in = open("/dev/tds0", O_RDONLY);  //foCX̃I[v
    fd_in = open(DEV_FILE, O_RDONLY);  //foCX̃I[v
    if (fd_in == -1) {
        perror("device open() error ");
        return -1;
    }
#ifdef _VSSP32
    printf("K5/VSSP32 (IP-VLBI) Board 1PPS Time Sync %s\n",TIMESYNC_VERSION);
#else
    printf("K5/VSSP (IP-VLBI) Board 1PPS Time Sync %s\n",TIMESYNC_VERSION);
#endif
    //1b̐ݒ
    rv = ioctl(fd_in, TDSIO_SYNC_1PPS);
    if (rv == -1) {
        perror("ioctl() 1pps sync failed ");
        return -1;
    }
    printf("1pps sync ok\n");

    time = 0; //Ôߏ
    secold=90000;
    counter=0;

    close(fd_in);
    // log out
    sprintf(cbuf,"timesync (OK)");
    if(LogWrite2(logdir,hostname,1,0.0,1,cbuf) == -1) printf("LogWrite2 error!\n");
    

    //foCX玞̎擾 and display while
    //fd_in = open("/dev/tds0", O_RDONLY);  //foCX̃I[v
    fd_in = open(DEV_FILE, O_RDONLY);  //foCX̃I[v
    if (fd_in == -1) {
        perror("device open() error ");
        return -1;
    }
    do{
#ifdef _VSSP32
       rv = ioctl(fd_in, TDSIO_GET_YEAR, &y3);
       yyyy=y3+2000;
#endif
       rv = ioctl(fd_in, TDSIO_GET_TIME, &time);
       if (rv == -1) {
          perror("ioctl() time get failed ");
          return -1;
       }
       day=TDS_GET_DAYS(time);
       sec=TDS_GET_SEC(time);
       if (sec!=secold) {
          sec2hms(sec,&h,&m,&s);
          //printf("get count day from device [%5d]\n",TDS_GET_DAYS(time));
          //printf("get count sec from device [%5d]\n",TDS_GET_SEC(time));
#ifdef _VSSP32
          printf("%04d/%03d %02d:%02d:%02d\n\033[A",yyyy,day,h,m,s);
#else
          printf("%03d %02d:%02d:%02d\n\033[A",day,h,m,s);
#endif
          counter++;
       }
       secold=sec;
    }while(counter <=secmax);
    close(fd_in);

    printf("\n\n");
    return 0;
}
